/*
 MPI  Windows.
:  . .
: 1.1
*/
#include "windows.h"
#define MPI
#include "windowsx.h"
#include "process.h"
#include "stdio.h"
#include "assert.h"
#include "mpi.h"

//   / -  

void concatstring(char *instring, int innumber, char **outstring);
int CheckInit(TQueue *Chain);
unsigned __stdcall AbortProc(void *param);
unsigned __stdcall SendProc(void *param);
unsigned __stdcall RecvProc(void *param);
int sizeofmpitype(MPI_Datatype datatype);

TQueue* CreateStruct (TQueue *Chain);
TQueue* Add(TQueue *Queue, TQueue *Chain);
TQueue* Del(TQueue *Chain);
int DelElem(TQueue *Chain);
TQueue* CopyElem(TQueue *Queue, TQueue *Chain);
TQueue* CreateElem(TQueue *Queue);
///////////////////////

//    
int NumberOfProcess = 1;//  .
int intrank; // 
int InitSign=0;// ,     MPI.
HANDLE hThreadAbort;
HANDLE hThreadSend;//  
HANDLE hThreadRecv;// 
HANDLE h_DataSendDefender = CreateMutex(NULL, FALSE, NULL);
HANDLE h_DataRecvDefender = CreateMutex(NULL, FALSE, NULL);
HANDLE h_StartSend = CreateSemaphore(NULL, 0, 2147483647, NULL);
HANDLE ProcessTerminate = CreateEvent(NULL, TRUE, FALSE, "Abort");
HANDLE h_Recv = CreateEvent(NULL, TRUE, FALSE, NULL);
TQueue **SendData; //= NULL;//  
TQueue *RecvData = NULL; //  
TQueue *InitRecvData = NULL;//  
//////////////////////////////////////////

//     
HANDLE h_Start = CreateEvent(NULL, TRUE, FALSE, "Start");//     .
HANDLE hm_Counter = CreateMutex(NULL, FALSE, "m_ProcessCounter");//   
HANDLE h_FileMap=NULL;											 //ProcessCounter.
HANDLE *h_SendMessage;
PINT ProcessCounter = 0;
//////////////////////////////////////////////

int MPI_Comm_size( MPI_Comm comm, int* size)
{
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}
	*size = NumberOfProcess;
	return MPI_SUCCESS;
}

int MPI_Comm_rank( MPI_Comm comm, int* rank)
{
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}

	*rank = intrank;
	return MPI_SUCCESS;
}

int MPI_Init(int *argc,char ***argv)
{
	InitSign = 1;//    .
	WaitForSingleObject(hm_Counter, INFINITE);//    .

	h_FileMap = OpenFileMapping(FILE_MAP_READ | FILE_MAP_WRITE, FALSE, TEXT("SharedProcessCounter"));
	if (h_FileMap==NULL) {
		h_FileMap= CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(ProcessCounter), TEXT("SharedProcessCounter"));
		ProcessCounter = (PINT) MapViewOfFile(h_FileMap, FILE_MAP_WRITE, 0, 0, 0);
		ProcessCounter[0] = 0;
	}
	else
	{
	ProcessCounter = (PINT) MapViewOfFile(h_FileMap, FILE_MAP_WRITE, 0, 0, 0);
	if (ProcessCounter[0] == NumberOfProcess) {
		MessageBox(0, "  \
		 ", "Attention", 0);
		ExitProcess(-1);
	}
	}
	// -  
	intrank = ProcessCounter[0];
	printf("Process: %d \n", intrank);
	ProcessCounter[0]++;

	//    
	h_SendMessage = new HANDLE [3*NumberOfProcess];
	for (int i = 0;i<NumberOfProcess;i++)
	{
		//itoa(i, &s, 10);
		char d1[] = "Message";
		char d2[] = "AttachToProcess";
		char d3[] = "ThreadIsBusy";
		char *SProcess;
		concatstring(d1, i, &SProcess);
		h_SendMessage[3 * i] = CreateEvent(NULL, FALSE, FALSE, TEXT(SProcess));
		concatstring(d2, i, &SProcess);
		h_SendMessage[3*i+1] = CreateMutex(NULL, FALSE, TEXT(SProcess));
		concatstring(d3, i, &SProcess);
		h_SendMessage[3*i+2] = CreateEvent(NULL, FALSE, FALSE, TEXT(SProcess));
		//d1[7] = s;
		//d2[15] = s;
		//d3[12] = s;
		//h_SendMessage[3*i+1] = CreateMutex(NULL, FALSE, TEXT(d2));
		//h_SendMessage[3*i+2] = CreateEvent(NULL, FALSE, FALSE, TEXT(d3));
	}
	///////////////////////////

	//  ,   
	SendData = new TQueue* [NumberOfProcess];
	for (int j = 0;j<NumberOfProcess;j++)
	SendData[j] = NULL;
	/////////////////////////////////////////////

	//   /
	hThreadAbort = (HANDLE)_beginthreadex( NULL, 0, &AbortProc, NULL, 0, NULL);
	hThreadSend = (HANDLE)_beginthreadex( NULL, 0, &SendProc, NULL, 0, NULL);
	hThreadRecv = (HANDLE)_beginthreadex( NULL, 0, &RecvProc, NULL, 0, NULL);
	///////////////////////////////////////

	//  
	if (ProcessCounter[0] == NumberOfProcess)
		SetEvent(h_Start);
	///////////////////////////
	ReleaseMutex(hm_Counter);
	WaitForSingleObject(h_Start, INFINITE);
	return MPI_SUCCESS;
}// MPI_Init

int MPI_Finalize()
{
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}
	InitSign = 0;
	WaitForSingleObject(h_DataSendDefender, INFINITE);
	for (int i=0;i<NumberOfProcess;i++)
		if (SendData[i] != NULL)
			break;
	ReleaseMutex(h_DataSendDefender);
	if (i != NumberOfProcess)
	{
		WaitForSingleObject(hThreadSend, INFINITE);
	}
	ProcessCounter[0]--;
	UnmapViewOfFile(ProcessCounter);
	CloseHandle(h_Start);
	CloseHandle(h_FileMap);
	CloseHandle(hThreadSend);
	CloseHandle(hThreadRecv);
	
	return MPI_SUCCESS;
}// MPI_Finalize

unsigned __stdcall SendProc(void *param)
{
/*
	    
	:
	1) ,      	
	2) . .       
	,    -    ,
	  - ,   ,  
	-   -   
	  .
	3)   
	4)     
	5) ,    
	6)   
	:
		        
	 h_DataSendDefender,      - 
	   h_StartSend.
		  SendData   RecvData . . 
	,       
	  ,    ,   
	   -.
*/
	//  
	char *SProcess;
	HANDLE h_MapSend;
	PBYTE h_SendBuffer;
	TQueue *Chain;
	PBYTE bufChain, buf;
	int i, random = intrank;
	char d[] = "Process";
	DWORD WaitSign = WAIT_TIMEOUT;
	////////////////////
	
	srand(NumberOfProcess);

	for( ; ;)
	{
	// ,      
	WaitForSingleObject(h_StartSend, INFINITE);
	
	// 
	// ,       
	//  - 
	while (WaitSign != WAIT_OBJECT_0)
	{
		//     
		WaitForSingleObject(h_DataSendDefender, INFINITE);
		
		random = rand()%NumberOfProcess;
		while (SendData [random] == NULL)
			random = rand()%NumberOfProcess;
		//       
		Chain = SendData[random];
		//     
		ReleaseMutex(h_DataSendDefender);

		WaitSign = WaitForSingleObject(h_SendMessage[3*Chain->dest+1], 1000);

		if (WaitSign == WAIT_FAILED)
		{
			MessageBox(0, "   ", "Attention", 0);
			exit(-1);
		}
				
	}
	WaitSign = WAIT_TIMEOUT;

	//  
	//itoa(Chain->dest, &SProcess, 10);
	//d[7] = SProcess;
	concatstring(d,Chain->dest, &SProcess);
	h_MapSend = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, sizeof(TQueue)+Chain->count*sizeof(Chain->datatype), TEXT(SProcess));//    
	h_SendBuffer = (PBYTE) MapViewOfFile(h_MapSend, FILE_MAP_WRITE, 0, 0, 0);

	bufChain = (PBYTE)Chain;
	for (i=0;i<sizeof(TQueue);i++)
		h_SendBuffer[i] = bufChain[i];

	buf = (PBYTE)Chain->buf;
	for (i=0;i<Chain->count*sizeofmpitype(Chain->datatype);i++)
		h_SendBuffer[i+sizeof(TQueue)] = buf[i];
	
	//////////////////////
	//     
	SetEvent(h_SendMessage[3*Chain->dest]);
	// ,    
	WaitForSingleObject(h_SendMessage[3*Chain->dest+2], INFINITE);

	//   
	UnmapViewOfFile(h_SendBuffer);
	CloseHandle(h_MapSend);

	ReleaseMutex(h_SendMessage[3*Chain->dest+1]);



	WaitForSingleObject(h_DataSendDefender, INFINITE);
	if (Chain->request != MPI_REQUEST_NULL)
		*(Chain->request) = 1;
	
	SendData[random] = Del(SendData[random]);
	free(Chain->buf);
	free(Chain);

	ReleaseMutex(h_DataSendDefender);

	WaitForSingleObject(h_DataSendDefender, INFINITE);
	for (i=0;i<NumberOfProcess;i++)
		if (SendData[i] != NULL)
			break;
	ReleaseMutex(h_DataSendDefender);
	if ((i == NumberOfProcess) && (InitSign == 0))
		return 0;
	}
	return 0;
}// SendProc()
unsigned __stdcall AbortProc(void *param)
{
	/*
	    
	:
	1)   ProcessTerminate -   
	 ,   ,    
	.
	2)   
	*/
	WaitForSingleObject(ProcessTerminate, INFINITE);
	ExitProcess(-1);
	return 0;//    .
}//AbortProc

unsigned __stdcall RecvProc(void *param)
/*
	    
	:
	1) ,      -
	h_SendMessage[3 * intrank]
	2)   ,     
	3)    
	4)     
	)     (     )
	   .
	)   -     
	5)   
	6)      -.
	h_SendMessage[3*Chain->dest+2]
	7)       MPI_Recv (h_Recv)
	:
	     - RecvData 
	   h_DataRecvDefender
*/
{

	char *SProcess;
	HANDLE h_RecvMap;//      
	PBYTE h_RecvBuffer;//      
	TQueue *Chain;
	PBYTE bufChain, buf;
	int i;
	char d[] = "Process";
	for ( ; ; )
	{
	
	WaitForSingleObject(h_SendMessage[3 * intrank], INFINITE);
	
	concatstring(d,intrank, &SProcess);
	h_RecvMap = OpenFileMapping (FILE_MAP_READ | FILE_MAP_WRITE, TRUE, TEXT(SProcess));
	h_RecvBuffer = (PBYTE) MapViewOfFile(h_RecvMap, FILE_MAP_WRITE, 0, 0, 0);
	
	if (h_RecvBuffer != NULL)
	{

		Chain = new (TQueue);
		bufChain = (PBYTE)Chain;
		for (i=0;i<sizeof(TQueue);i++)
			bufChain[i] = h_RecvBuffer[i];

		buf = (PBYTE) malloc(Chain->count*sizeofmpitype(Chain->datatype));
		Chain->buf = buf;
		for (i=0; i<Chain->count*sizeofmpitype(Chain->datatype); i++)
			buf[i] = h_RecvBuffer[i+sizeof(TQueue)];
		//  ,  ,  ...
		

		WaitForSingleObject(h_DataRecvDefender, INFINITE);
		if (CheckInit(Chain) == 0)
		{			
			Chain->request = MPI_REQUEST_NULL;
			Chain->IsEmpty = 1;
			RecvData = Add(RecvData, Chain);
		}
		else
		{
			Chain->request = new (int);
			*(Chain->request) = 1;
			RecvData = CopyElem(RecvData, Chain);
		}
		
		ReleaseMutex(h_DataRecvDefender);
		
	}
	else
		MessageBox(0,"h_FileMap are NULL", "Attention", 0);


	UnmapViewOfFile(h_RecvBuffer);
	CloseHandle(h_RecvMap);
	//    
	SetEvent(h_SendMessage[3*Chain->dest+2]);
	// 6)   
		SetEvent(h_Recv);
		ResetEvent(h_Recv);

	}
	return 0;
}

int MPI_Send(void* buf, int count, MPI_Datatype datatype, int dest, int msgtag, MPI_Comm comm)
{
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}
	if ((dest>=NumberOfProcess) || (dest < 0))
	{
		return MPI_ERR_RANK;
	}
	// 1)    .
	TQueue *Chain = new TQueue;
	
	//  ,      
	PBYTE buf1 = (PBYTE)malloc (sizeofmpitype(datatype)*count);

	PBYTE buf2 = (PBYTE) buf;
	for (int i = 0; i<sizeofmpitype(datatype)*count; i++)
		buf1[i] = buf2[i];
	Chain->buf = buf1;
	////////////////////////////////////////////////////////////////

	Chain->count = count;
	Chain->datatype = datatype;
	Chain->dest = dest;
	Chain->source = intrank;
	Chain->msgtag = msgtag;
	Chain->IsEmpty = 0; //  ,    
	Chain->comm = comm;
	Chain->request = MPI_REQUEST_NULL;
	
	// 2)     
	WaitForSingleObject(h_DataSendDefender, INFINITE);
	// 3)   
	SendData[dest] = Add(SendData[dest], Chain);
	
	// 3)       
	ReleaseSemaphore(h_StartSend,1,NULL);
	// 4)    
	ReleaseMutex(h_DataSendDefender);

	return MPI_SUCCESS;
}// MPI_Send

int MPI_Isend(void* buf, int count, MPI_Datatype datatype, int dest, int msgtag, MPI_Comm comm, MPI_Request *request)
{
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}
	if ((dest>=NumberOfProcess) || (dest < 0))
	{
		return MPI_ERR_RANK;
	}
	// 1)    .
	TQueue *Chain = new TQueue;
	
	//  ,      
	PBYTE buf1 = (PBYTE)malloc (sizeofmpitype(datatype)*count);

	PBYTE buf2 = (PBYTE) buf;
	for (int i = 0; i<sizeofmpitype(datatype)*count; i++)
		buf1[i] = buf2[i];
	Chain->buf = buf1;
	////////////////////////////////////////////////////////////////

	Chain->count = count;
	Chain->datatype = datatype;
	Chain->dest = dest;
	Chain->source = intrank;
	Chain->msgtag = msgtag;
	Chain->IsEmpty = 0;
	Chain->comm = comm;
	Chain->request = new (int);
	*(Chain->request) = 0;
	*request = Chain->request;
	// 2)     
	WaitForSingleObject(h_DataSendDefender, INFINITE);
	// 3)   
	SendData[dest] = Add(SendData[dest], Chain);
	
	// 3)       
	ReleaseSemaphore(h_StartSend,1,NULL);
	// 4)    
	ReleaseMutex(h_DataSendDefender);

	return MPI_SUCCESS;
}// MPI_Isend

int MPI_Recv(void* buf, int count, MPI_Datatype datatype, int source, int msgtag, MPI_Comm comm, MPI_Status *status)
{
	int i;
	PBYTE buf1, buf2;
	TQueue *Tmp;
	TQueue *Tmp1;
	int AddSign;

	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}

	AddSign = 0;//Issend

	while (1 == 1) {
	WaitForSingleObject(h_DataRecvDefender, INFINITE);
	Tmp = RecvData;
	while (RecvData != NULL)
	{
		if (((RecvData->msgtag == msgtag) || (msgtag == MPI_ANY_TAG))   && \
			((RecvData->source == source) || (source == MPI_ANY_SOURCE))&& \
			 (RecvData->comm == comm)									&& \
			 (RecvData->request == MPI_REQUEST_NULL)					&& \
			 (RecvData->IsEmpty == 1))
		{		
			if (count*sizeofmpitype(datatype) >= RecvData->count*sizeofmpitype(RecvData->datatype))
			{
				buf1 = (PBYTE)RecvData->buf;
				buf2 = (PBYTE)buf;
				for (i=0; i<RecvData->count*sizeofmpitype(RecvData->datatype); i++)
					buf2[i] = buf1[i];
				if (status != NULL)
				{
					status->count = RecvData->count;
					status->MPI_SOURCE = RecvData->source;
					status->MPI_TAG = RecvData->msgtag;
					status->MPI_ERROR = 0;
				}
				
				Tmp1 = RecvData;
				RecvData = Del(RecvData);
				free(Tmp1);
				ReleaseMutex(h_DataRecvDefender);
				return MPI_SUCCESS;
			}
			else
			{
				ReleaseMutex(h_DataRecvDefender);
				return MPI_ERR_COUNT;
			}
		}
		RecvData = RecvData->Next;
	}
	//    
		if (AddSign == 0)
		{
			AddSign = 1;
			TQueue *Chain ;
			Chain = new TQueue;
			Chain->buf = malloc (sizeofmpitype(datatype)*count);
			Chain->count = count;
			Chain->datatype = datatype;
			Chain->dest = intrank;
			Chain->source = source;
			Chain->msgtag = msgtag;
			Chain->comm = comm;
			Chain->IsEmpty = 0;
			Chain->request = MPI_REQUEST_NULL;
			RecvData = Add(RecvData, Chain);
		}
		
		RecvData = Tmp;
		ReleaseMutex(h_DataRecvDefender);
		WaitForSingleObject(h_Recv, 2000);
	}
	///////////////////////
	//      
	
	return MPI_SUCCESS;
}//Recv

int MPI_Irecv(void* buf, int count, MPI_Datatype datatype, int source, int msgtag, MPI_Comm comm, MPI_Request *request)
{
	int i;
	PBYTE buf1, buf2;
	TQueue *Tmp;
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}

	WaitForSingleObject(h_DataRecvDefender, INFINITE);
	Tmp = RecvData;
	while (RecvData != NULL)
	{
		if (((RecvData->msgtag == msgtag) || (msgtag == MPI_ANY_TAG))   && \
			((RecvData->source == source) || (source == MPI_ANY_SOURCE))&& \
			 (RecvData->comm == comm)									&& \
			 (RecvData->request == MPI_REQUEST_NULL)					&& \
			 (RecvData->IsEmpty == 1))
		{		
			if (count*sizeofmpitype(datatype) >= RecvData->count*sizeofmpitype(RecvData->datatype))
			{
				buf1 = (PBYTE)RecvData->buf;
				buf2 = (PBYTE)buf;
				for (i=0; i<RecvData->count*sizeofmpitype(RecvData->datatype); i++)
					buf2[i] = buf1[i];
				
				*request = new (int);
				**request = 1;
				RecvData->request = *request;
				RecvData = RecvData->Head;
				ReleaseMutex(h_DataRecvDefender);
				return MPI_SUCCESS;
			}
			else
			{
				ReleaseMutex(h_DataRecvDefender);
				return MPI_ERR_COUNT;
			}
		}
		RecvData = RecvData->Next;
	}
	//    
		RecvData = Tmp;

		TQueue *Chain ;
		Chain = new TQueue;
		Chain->buf = buf;
		Chain->count = count;
		Chain->datatype = datatype;
		Chain->dest = intrank;
		Chain->source = source;
		Chain->msgtag = msgtag;
		Chain->comm = comm;
		Chain->IsEmpty = 0;
		Chain->request = new (int);
		*(Chain->request) = 0;
		*request = Chain->request;
		RecvData = Add(RecvData, Chain);
		ReleaseMutex(h_DataRecvDefender);

		return MPI_SUCCESS;
}// Irecv

int MPI_Test(MPI_Request *request, int *flag, MPI_Status *status)
{
	TQueue *Tmp;
	WaitForSingleObject(h_DataRecvDefender, INFINITE);
	if (*request == MPI_REQUEST_NULL)
		return MPI_ERR_REQUEST;
	if (flag == NULL)
		return MPI_ERR_ARG;
	if  (**request == 1)
	{
		Tmp = RecvData;
		while (RecvData != NULL)
		{
			if (RecvData->request == *request)
			{
				if (status != NULL)
				{
					status->count = RecvData->count;
					status->MPI_SOURCE = RecvData->source;
					status->MPI_TAG = RecvData->msgtag;
					status->MPI_ERROR = 0;
				}
				*flag = 1;
				free(*request);
				*request = MPI_REQUEST_NULL;
				TQueue *Tmp1 = RecvData;
				RecvData = Del(RecvData);
				free(Tmp1);
				ReleaseMutex(h_DataRecvDefender);
				
				return MPI_SUCCESS;
			}// if
			RecvData = RecvData->Next;
		}// while
		*flag = 1;
		free(*request);
		*request = MPI_REQUEST_NULL;
		RecvData = Tmp;
	}
	
	else
		*flag = 0;

	ReleaseMutex(h_DataRecvDefender);
	return MPI_SUCCESS;
}

int MPI_Get_count( MPI_Status *status, MPI_Datatype datatype, int *count)
{
	*count = status->count;
	return MPI_SUCCESS;
}

int MPI_Barrier(MPI_Comm comm)
{
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}
	HANDLE MPIBarrierEnd = CreateEvent(NULL, TRUE, FALSE, "EndBarrier");
	ProcessCounter[0]--;
	if (ProcessCounter[0] == 0)
	{
		SetEvent(MPIBarrierEnd);
		ResetEvent(MPIBarrierEnd);
	}
	else
		WaitForSingleObject(MPIBarrierEnd, INFINITE);

	WaitForSingleObject(hm_Counter, INFINITE);
	ProcessCounter[0]++;
	ReleaseMutex(hm_Counter);
	CloseHandle(MPIBarrierEnd);

	return MPI_SUCCESS;
}

int MPI_Abort( MPI_Comm comm, int errorcode)
{
	if (InitSign == 0)
	{
		MessageBox(0, "   MPI_INIT() !", "Attention", 0);
		exit(-1);
	}
	SetEvent(ProcessTerminate);
	return MPI_SUCCESS;
}

int sizeofmpitype(MPI_Datatype datatype)
//      
{
	switch (datatype) {
	case MPI_BYTE :
		return sizeof(char);
	case MPI_CHAR :
		return sizeof(signed char);
		break;
	case MPI_INT :
		return sizeof(signed int);
		break;
	case MPI_SHORT :
		return sizeof(signed int);
		break;
	case MPI_LONG :
		return sizeof(signed long int);
		break;
	case MPI_UNSIGNED_CHAR :
		return sizeof(unsigned char);
		break;
	case MPI_UNSIGNED_SHORT :
		return sizeof(unsigned int);
		break;
	case MPI_UNSIGNED :
		return sizeof(unsigned int);
		break;
	case MPI_UNSIGNED_LONG :
		return sizeof(unsigned long int);
		break;
	case MPI_FLOAT :
		return sizeof(float);
		break;
	case MPI_DOUBLE :
		return sizeof(double);
		break;
	case MPI_LONG_DOUBLE :
		return sizeof(long double);
		break;
	default:
		return 0;
		break;
	} /* switch(datatype)*/

}//sizeofmpitype

TQueue* Add(TQueue *Queue, TQueue *Chain)
//     
{
	Chain->Next = NULL;

	if (Queue != NULL)
	{
		while (Queue->Next != NULL)
			Queue = Queue->Next;
		Queue->Next = Chain;
		Chain->Head = Queue->Head;
	}
	else
	{
		Queue = Chain;
		Queue->Head = Queue;
	}

	Queue = Queue->Head;
	return Queue;
}// Add()

TQueue* Del(TQueue *Chain)
{//    
	if (Chain == NULL)
		return NULL;

	TQueue *Tmp = Chain;
	Chain = Chain->Head;

	if (Chain->Next == NULL)
		return NULL;

	if (Tmp == Chain)
	{
		while (Chain->Next != NULL)
		{
			Chain = Chain->Next;
			Chain->Head = Tmp->Next;
		}
		Chain = Chain->Head;
		Tmp->Head = NULL;
		Tmp->Next = NULL;
		return Chain;
	}
	
	while (Chain->Next != Tmp)
		Chain = Chain->Next;

	Chain->Next = Tmp->Next;
	Tmp->Head = NULL;
	Tmp->Next = NULL;
	
	Chain = Chain->Head;
	return Chain;
}

int DelElem(TQueue *Chain)
{//   
	if (Chain == NULL)
		return -1;

	if (Chain->buf != NULL)
	{
		free(Chain->buf);
		Chain->buf = NULL;
	}
	if (Chain->request != MPI_REQUEST_NULL)
	{
		free(Chain->request);
		Chain->request = MPI_REQUEST_NULL;
	}
	Chain->Next = NULL;
	Chain->Head = NULL;
	free(Chain);
	return 0;
}

TQueue* CopyElem(TQueue *Queue, TQueue *Chain)
{//      
	PBYTE buf1, buf2;
	//if (Queue->buf == NULL)
	//	Queue->buf = malloc(Chain->count * sizeofmpitype(Chain->datatype));

	Queue->comm = Chain->comm;
	Queue->datatype = Chain->datatype;
	Queue->source = Chain->source;
	Queue->msgtag = Chain->msgtag;
	Queue->IsEmpty = 1;
	Queue->count = Chain->count;
	Queue->dest = Chain->dest;
	if (Queue->request != MPI_REQUEST_NULL)
		*(Queue->request) = *(Chain->request);
	buf1 = (PBYTE) Chain->buf;
	buf2 = (PBYTE) Queue->buf;
	for (int i = 0; (i<Queue->count*sizeofmpitype(Queue->datatype))\
		&& (i<Chain->count*sizeofmpitype(Chain->datatype));i++)
		buf2[i] = buf1[i];
	Queue = Queue->Head;
	return Queue;
}

TQueue* CreateElem(TQueue *Queue)
{
//      
//   -      ()
	TQueue *Chain = new TQueue;
	if (Queue != NULL)
	{
		Queue = Queue ->Head;
		while (Queue->Next != NULL)
			Queue = Queue->Next;
		Queue->Next = Chain;
		Chain->Next = NULL;
		Chain->Head = Queue->Head;
		Chain->buf = NULL;
		Chain->IsEmpty = 0;
	}
	else
	{
		Queue = Chain;
		Queue->Next = NULL;
		Queue->Head = Queue;
	}
	Chain->buf = NULL;
	return Chain;
}

int CheckInit(TQueue *Chain)
{//      
	// : ,    
	// : 0 -   , 1 - .
	//   ,       - 
	// ,   -    
	if (RecvData == NULL)
		return 0;
	//    
	RecvData = RecvData->Head;
	//   
	TQueue *Tmp;
	Tmp = RecvData;
	while (RecvData != NULL)
		if ((RecvData->IsEmpty == 0)														&& \
			((Chain->msgtag == RecvData->msgtag) || (RecvData->msgtag == MPI_ANY_TAG))		&& \
			((Chain->source == RecvData->source) || (RecvData->source == MPI_ANY_SOURCE))	&& \
			(Chain->comm == RecvData->comm))
			return 1;
		else
			RecvData = RecvData->Next;
	RecvData = Tmp;

	return 0;
}
int NumberOfProcesses(int size)
{
	NumberOfProcess = size;
	return 0;
}

int MPI_Issend(void* buf, int count, MPI_Datatype datatype, \
		int dest, int msgtag, MPI_Comm comm, MPI_Request *request)
//    
//   
{

	int res;
	res = MPI_Isend(buf,count,datatype,dest,msgtag, comm, request);
	assert(res==MPI_SUCCESS);

	return res;
}

#include "stdlib.h"
#include "string.h"

void concatstring(char *instring, int innumber, char **outstring)
//    -     
//  .
{
	int k=0,l=0,j=0;
	char *s2 = new char [10];
	itoa(innumber, s2, 10);

	while (instring[l]!='\0')
		l++;
	while (s2[k]!='\0')
		k++;
	*outstring = new char [l+k+1];
	for(j=0;j<l;j++)
		(*outstring)[j] = instring[j];
	(*outstring)[l] = '\0';
	strcat(*outstring,s2);
	for (j=0;j<10;j++)
		s2++;
}